;+
; :Description:
;    Describe the procedure.
;   This program is used into Triple collocation analysis
;   calculate the covairance between two soil moisture products
;   RMSE are calculated between three uncorelated soil moisture products based on Triple collocation analysis method
;
;   covariance=E(x*y)-E(x)*E(y);x：first soil moisture product，y：second soil moisture product
;   this program is used to calculate the X*y image data对应每天的日期下
;   then，利用multi_image_average_batch.pro program to calcluate the E(X*Y)
;   then, by Envi software, covarience is calculaed. E(x)and E(y) are the year-mean image data
;   finally, the RMSE of different SM products are calculated by TCA equations(McColl et al.2014)
;
; :Author: xieqiuxia
;-
pro TCA_multiply_average

  COMPILE_OPT idl2
  ENVI,/restore_base_save_files
  envi_batch_init,LOG_FILE='batch.log'

  ;设置文件关键字,1:ASCAT,2:SMOS-IC,3:FY3B
  file1='Fusion'
  file2='SMAP'

  ;获取第一景影像路径
  ;paths1='E:\Data\SM_Products\FY3\B-VSM(2011-2017)\'
  paths1='J:\Merging_SM_Products_SMOS_FY3B_ASCAT_1\SMOS_FY3B_ASCAT_2012_2017_SM_Fusion_DATA\Daily_P\'
  
  ;paths1='E:\Data\SM_Products\ESACCI\Daily\'
  ;paths1='E:\Data\SM_Products\ASCAT\G2_BIOPAR_SWI\25km_Daily_V3_Porosity\'
  ;paths1='E:\Data\SM_Products\SMOS\L3_SMOS_IC_Soil_Moisture\Conversion\'
 
  ;获取第二景影像路径
  ;paths2='E:\Data\SM_Products\ESACCI\Daily\'
  ;paths2='J:\Merging_SM_Products_SMOS_FY3B_ASCAT_1\SMOS_FY3B_ASCAT_2012_2017_SM_Fusion_DATA\Daily_P\'
  paths2='D:\SM_Products\SMAP\L3_SM_PE_9km_Enhanced_Resample_25km\'
  ;paths2='E:\Data\SM_Products\FY3\B-VSM(2011-2017)\'

  ;设置升降轨道类；'D' and 'A'
  D_A='D'

  ;设置输出影像路径
  ;outfiledir='J:\Merging_SM_Products_Fusion_ESACCI_SMAP_2\Fusion_ESACCI_SMAP_2015_2017_Global_SM_Mean\'
  outfiledir='J:\Merging_SM_Products_Fusion_ESACCI_SMAP_2\Fusion_ESACCI_SMAP_2015_2017_Global_SM_Mean_P\'
  
  ;设置时间范围
  year=2015;起始年
  year_e=2017;结束年
  month=1;起始月
  month_e=12;结束月
  day=1;起始天
  day_e=31;结束天

;  year1=year;起始年
;  year_e1=year_e;结束年
;  month1=month;起始月
;  month_e1=month_e;结束月
;  day1=day;起始天
;  day_e1=day_e;结束天
  
  out_name=outfiledir+file1+'_'+file2+'_'+'2015_2017_Average_'+D_A+'.tif

  re=num_file1_file2(paths1,paths2,D_A,file1,file2,year,year_e,month,month_e,day,day_e)
  
  ;re=[1096,1440,720] ;ESACCI
  ;re=[1003,1440,680] ;SMAP
  ;re=[1003,1440,720] ;ESACCI SMAP
  ;re=[1036,1440,680] ;Fusion
  ;re=[947,1440,680] ;Fusion,SMAP
  ;re=[1039,1440,720] ;Fusion,ESACCI
  ;re=[1003,1440,720] ;ESACCI,SMAP
  ;re=[1036,1440,720]
  print,re
 
  name=file1_file2_Multiplication(paths1,paths2,D_A,outfiledir,file1,file2,year,year_e,month,month_e,day,day_e,re,out_name)
  print,name

end


